#include <stdlib.h>
#include <stdio.h>



void replace(char *string, int index, int size, int string_size) {
    for (int pos = index; pos < size + index; pos++) {
        string[pos] = '#';
    }
    printf("stri: %s\n", string);
    return;
}

int main() {
    int n,q;
    scanf("%d %d", &n,&q);
    
    char string[n];// = malloc(n);
    int arr[n];// = malloc(n * sizeof(int));
    for (size_t i = 0; i < n; i++)
    {
        arr[i] = 0;
    }
    
    int sizeI = 0;
    int succsesfulInc = 0;

    scanf("%s", string);
    // scanf("%c", &c);
    for (int i = 0; i < q; i++){

        scanf("%d", &sizeI);
        //printf("%d\n", sizeI);
        // char* inci = malloc(sizeI);
        char inci[sizeI];
        scanf("%s", inci);
        //for(int ii = 0; ii < sizeI + 1; ii++){
            //printf("%c", inci[ii]);
        //}

        succsesfulInc = 0;

        // printf("searching for %s\n", inci);
        //mame co chcem odebrat
        for(int ii = 0; ii + sizeI < n; ii++){
            
            //skip przdne casti
            // printf("D: %d %c\n", arr[ii], string[ii]);
            if(string[ii] == '#')
               ii += arr[ii]; 
            // mame schodu prvniho pismene
            // printf("%c\n", inci[1]);
            if(ii >= n) break;
            /*else*/ if(string[ii] == inci[0]){
                //printf("%c %c \n", string[ii], inci[1]);
                //find schoda
                int iter = 1;
                int offset = 0;
                for(iter = 1; iter < sizeI ; iter ++){
                    // printf("%c %c\n", inci[iter], string[iter+ii]);
                    offset += arr[iter+ii+offset];
                    if(inci[iter] != string[iter + ii + offset]) {
                        break;
                    }
                }

                if(iter  == sizeI){
                    succsesfulInc++;
                    //vymaz
                    arr[ii] = sizeI;
                    replace(string, ii, sizeI, n);
                    ii += sizeI;
                    // // n -= sizeI;
                    // for(int nn = 0; nn < n; nn++){
                    //     printf("%c", string[nn]);
                    // }    
                    // printf("\n");

                }
            }
        }

        //mame pocet a vymazano
        // free(inci);
        printf("%d\n", succsesfulInc);

    }
    return 0;
}